#include <iostream>
#include "BinTreeIOint.hh"

/* Este algoritmo es lineal en el número de nodos de a. */

// Compilar con p2++ -o a.x equilib_res.cc BinTreeIOint.cc

pair<bool,int> equil_res(const BinTree<int>& a) {
/* Pre: cierto */
/* Post: La primera componente del resultado indica si a es equilibrado. 
Si la primera componente del resultado es cierta, la segunda componente 
del resultaod es la altura de a. */
/* Coste: O(n), donde n es el número de nodos de a. */
  pair<bool,int> r; 
  if (a.empty()) r = make_pair(true,0);
  else {
     r = equil_res(a.left());
     /* HI: r.first indica si a.left() es equilibrado. Si r.first es true, 
     r.second es la altura de a.left(). */
     if (r.first) {
        pair<bool,int> r2 = equil_res(a.right()); 
     /* HI: r2.first indica si a.right() es equilibrado. Si r2.first es true, 
     r.second es la altura de a.right(). */
	if (r2.first) r.first = abs(r.second - r2.second) <= 1;
	else r.first = false;
        if (r.first) r.second = max(r.second, r2.second) + 1; 
     }
  }
  return r;
}


int main() {
  BinTree<int> a = read();
  cout << endl << "a: "; 
  write(a);
  if (equil_res(a).first) cout << endl << "equilibrado" << endl;
  else cout << endl << "no equilibrado" << endl;
}
