#include <iostream> 
using namespace std; 


// Muy ineficiente Se puede demostrar por inducción que fib(n) hace
// aproximadamente fib(n+1) llamadas recursivas, cada una de las
// cuales realiza un número constante de instrucciones básicas. Como
// se sabe que fib(n) es proporcional a una constante mayor que 1
// elevada a n, el algoritmo es exponencial en n. 

int fib(int n) {
/* Pre: n >= 0 */
/* Post: el resultado es el término n-ésimo de la sucesión de Fibonacci */
/* Coste: exponencial en n */
  int r; 
  if (n < 2) r = n; 
  else r = fib(n-1) + fib(n-2); 
  return r; 
}


int main() {
  int x; 
  cin >> x; 
  cout << fib(x) << endl; 
}















